
#ifndef __DDFS__HEADER___
#define __DDFS__HEADER___

#define  print_md5_result(md5_result) \
	printk(KERN_INFO "in %s,%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X",__FUNCTION__, \
		md5_result[0], md5_result[1], md5_result[2], md5_result[3], md5_result[4], md5_result[5], \
		md5_result[6], md5_result[7], md5_result[8], md5_result[9], md5_result[10], md5_result[11],\
		md5_result[12], md5_result[13], md5_result[14], md5_result[15]);


#define  sprint_md5_result(buf,md5_result) \
	sprintf(buf,"in %s,%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X",__FUNCTION__, \
		md5_result[0], md5_result[1], md5_result[2], md5_result[3], md5_result[4], md5_result[5], \
		md5_result[6], md5_result[7], md5_result[8], md5_result[9], md5_result[10], md5_result[11],\
		md5_result[12], md5_result[13], md5_result[14], md5_result[15]);
//void print_md5_result(unsigned char md5_result[16]);
unsigned ddfs_map_blocks(handle_t * handle,struct inode * inode,
			sector_t iblock,unsigned long maxblocks,ext3_fsblk_t blk_to_map);
unsigned ddfs_remove_mapped_block(handle_t* handle, struct inode * inode,
		__u32 iblock);
int ddfs_block_write_begin(struct file *file, struct address_space *mapping,
			loff_t pos, unsigned len, unsigned flags,
			struct page **pagep, void **fsdata,
			get_block_t *get_block);

#define DDFS_DEBUG
#endif

